rm(list=ls(all=TRUE))  # clean up left overs from previous run, though shouldn't need to.
library(PolynomF)
library(plotrix)
source("C:/Users/radivot/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R")
load("C:/Users/radivot/case/active/rnr/RXC/results/G0.RData")
if (!is.null(dev.list())) for (i in 2:max(dev.list())) dev.off(i);
windows(width = 8, height = 8,restoreConsole = TRUE,ypos=0)
par(mfrow=c(2,2),mar=c(4.2,4,2,1)+.1) #,oma=c(0,0,3,1))
SSE=sapply(G,function(x) x$SSE$final)
hist(SSE,breaks=50)
(intvf=cut(SSE,breaks=c(0,3*min(SSE),.014,1))) #,labels=paste("G",1:5,sep="")))
#Xg <- c(seq(0,400,by=25),seq(400,3000,by=100)) 
Xg <- c(seq(0,400,by=25),seq(400,3200,by=100),seq(9900,10100,by=100)) 
pd=data.frame(RT=1.2, XT=Xg)
for (i in levels(intvf)) {
  with(G[[1]]$d,gap.plot(XT,k,gap=c(3300,9900),xtics=c(0,500,1000,2000,3000),
          gap.axis="x",ylim=c(.1,.3),xlim=c(0,3500),ylab="CDP Reductase Activity (1/sec)",xlab="[ATP] in uM"))
#  with(G[[1]]$d,plot(XT,k,ylim=c(.1,.3),ylab="CDP Reductase Activity (1/sec)",xlab="[ATP] in uM"))
  title(paste("SSE in",i),line=0.4,cex.main=1)
  for (pg in G[intvf==i]) {
    pg$d=pd
    pg=getEk(pg)
    with(pg$d,lines(XT,Ek))
#    with(pg$d,gap.plot(XT,k,gap=c(3300,9900),xlim=c(0,3500),add=TRUE))
  }
with(G[[1]]$d,points(XT,k,pch="X",col="red",cex=2))  # this works just as well  (can't get the last point up in big red)
#with(G[[1]]$d,gap.plot(XT,k,gap=c(3300,9900),xlim=c(0,3500),type="p",pch="X",col="red",cex=2,add=TRUE))
text(1500,0.1,paste("Number of models =",sum(intvf==i)))
}


windows(width = 4, height = 4,restoreConsole = TRUE,ypos=0)
par(mfrow=c(1,1),mar=c(4.2,4,2,1)+.1) #,oma=c(0,0,3,1))
#with(G[[1]]$d,plot(XT,k,ylim=c(.1,.3),ylab="CDP Reductase Activity (1/sec)",xlab="[ATP] in uM"))
with(G[[1]]$d,gap.plot(XT,k,gap=c(3300,9900),xtics=c(0,500,1000,2000,3000),
        gap.axis="x",ylim=c(.1,.3),xlim=c(0,3500),ylab="CDP Reductase Activity (1/sec)",xlab="[ATP] in uM"))
title("Top 4 Models",line=0.4,cex.main=1)
sG=sortG(G)
for (i in 1:4) {
  pg=sG[[i]]
  pg$d=pd
  pg=getEk(pg)
  with(pg$d,lines(XT,Ek,lty=i))
}
legend(1400,0.17,legend=sapply(sG[1:4],function(x) x$id),lty=1:4,bty="n")
